Description

ICARUS is having an issue where BoardReaders crash while stopping. This occurs because of a missing lock in FragmentBuffer.

The DataBuffers are cleared after a different thread has determined that the buffer was over-size, but before it prints the timestamp
range of the buffer. When that thread goes to print the timestamp range, it tries to dereference a null pointer.

History

#1 - 12/17/2020 08:33 AM - Eric Flumerfelt

- Status changed from New to Resolved

Resolution on artdaqg:bugfix/25328_MissingLockInFragmentBuffer

#2 - 12/17/2020 11:35 AM - Wesley Ketchum

Relatedly (but separate, | know...): can we make it optional to have the warning message for filling up the FragmentBuffer? When we're running in
window mode and intending to use that buffer like a circular buffer, we get a spew of warning messages consistently through the run.

#3 - 12/17/2020 01:04 PM - Eric Flumerfelt

Is there a reason to not have circular_buffer_mode set, then? The "Bad Omen" messages are only printed if you're not in circular_buffer_mode.

Right now, the buffer is automatically flushed by timestamp latency only. Do we want to add a wall-clock latency (i.e. using chrono::steady_clock)?
You could then configure both the buffer size limits to be zero and rely on the latency removal (of either kind) (or system memory limits) to moderate
the buffer size.

#4 - 01/06/2021 12:09 PM - Gennadiy Lukhanin

- Status changed from Resolved to Reviewed

artdaq:bugfix/25328_MissingLockInFragmentBuffer and artdag-utilities:bugfix/25328_ThreadContentionFixes were code reviewed, tested on the
Icarus cluster for interference with the SBN DAQ software (run 4300), and merged into the develop branch.

#5 - 01/08/2021 02:39 PM - Eric Flumerfelt
- Target version set to artdaq v3_09_04

- Status changed from Reviewed to Closed
